package laplace;

import muscle.core.kernel.Submodel;
import muscle.core.ConduitExit;
import muscle.core.ConduitEntrance;
import muscle.core.model.Timestamp;

/* Inverts and exchanges a left and right boundary, initializing to 0 */
public class Inverter extends Submodel {
    int ny;
    double[] eastValue, westValue;

    @Override
    protected Timestamp init(Timestamp prevTime) {
        ny = getIntProperty("ny");
        eastValue = westValue = new double[ny];

        return super.init(prevTime);
    }

    @Override
    protected void intermediateObservation() {
        this.<double[]>out("westBoundary").send(eastValue);
        this.<double[]>out("eastBoundary").send(westValue);
    }
    
    @Override
    protected void solvingStep() {
        eastValue = this.<double[]>in("remoteEast").receive();
        westValue = this.<double[]>in("remoteWest").receive();

        for (int i = 0; i < ny; i++) {
            eastValue[i] = -eastValue[i];
            westValue[i] = -westValue[i];
        }
    }
}
