package laplace.filter;

import muscle.core.conduit.filter.AbstractFilter;
import muscle.core.model.Observation;
import muscle.util.data.SerializableDatatype;

// A filter from double[] to double[]
public class InvertFilter extends AbstractFilter<double[],double[]> {
    public void apply(Observation<double[]> obs) {
        // Do not modify the original data of the submodel, so make a private copy and use the resulting data
        // If you supply the datatype in advance (DOUBLE_ARR), the copy operation will be faster.
        Observation<double[]> output = obs.privateCopy(SerializableDatatype.DOUBLE_ARR);
        double[] data = output.getData();

		// Perfrom the inversion
        for (int i = 0; i < data.length; i++) {
            data[i] = -data[i];
        }

        // Create a new observation for the data
        put(output);
    }
}
