package laplace.mapper;

import muscle.core.kernel.FanInMapper;
import muscle.core.model.Observation;

public class CombineDoubleMapper extends FanInMapper<double[]> {
	double[] data = null;

	// A fan-in mapper only needs to set the variable "value", and that will be sent
	@Override
	protected void receiveAll() {
		Observation<double[]> in1obs = this.<double[]>in("in1").receiveObservation();
		final double[] in1 = in1obs.getData();
		final double[] in2 = this.<double[]>in("in2").receive();

		if (data == null) {
			data = new double[in1.length + in2.length];
		}
		// Combine the arrays
		System.arraycopy(in1, 0, data, 0, in1.length);
		System.arraycopy(in2, 0, data, in1.length, in2.length);

		value = in1obs.copyWithNewData(data);
	}
}
