package laplace.mapper;

import muscle.core.kernel.FanOutMapper;
import muscle.core.model.Observation;

public class DivideDoubleMapper extends FanOutMapper<double[]> {
	double[] out1, out2;

	@Override
	protected void init() {
		out1 = new double[getIntProperty("size1")];
		out2 = new double[getIntProperty("size2")];
	}
	// A fan-in mapper only needs to set the variable "value", and that will be sent
	@Override
	protected void sendAll() {
		final double[] data = value.getData();
		
		// Divide the data over the two output arrays
		System.arraycopy(data, 0, out1, 0, out1.length);
		System.arraycopy(data, out1.length, out2, 0, out2.length);
		
		this.<double[]>out("out1").send(out1);
		this.<double[]>out("out2").send(out2);
	}
}
