package laplace.terminal;

import muscle.core.conduit.terminal.Source;
import muscle.core.model.Timestamp;
import muscle.core.model.Observation;

public class DoubleArraySource extends Source<double[]> {
    private double[] data;
    private int iteration = 0;
    
    @Override
    public Observation<double[]> take() {
        // Initialize data
        if (iteration == 0) {
            int size = getIntProperty("size");
            data = new double[size];

            double value = getDoubleProperty("value");
            for (int i = 0; i < size; i++) {
                data[i] = value;
            }
        }

        iteration++;
        return new Observation<double[]>(data, new Timestamp(iteration-1), new Timestamp(iteration));
    }

    // This source is never empty
    @Override
    public boolean isEmpty() { return false; }
}
